#include "pe.h"
#include "glio.h"

static int	restrict(int *x,int *y)
{
	if (*x < 0)	*x = 0;
	if (*x > drwidth)	*x = drwidth;
	if (*y < 0)	*y = 0;
	if (*y > drheight) *y = drheight;
}

static int	restrictmouse(int *x,int *y)
{
	XEvent ev;
	int	ret=0,_x,_y;
	extern void Move_org(Widget, XtPointer, XtPointer);

	do{
		XNextEvent(XtDisplay(Draw),&ev);
	}while(!((ev.type == ButtonPress)||(ev.type == MotionNotify)));

	switch(ev.type){
	case ButtonPress:
		_x = ev.xbutton.x;
		_y = ev.xbutton.y;
		if( ev.xbutton.window == XtWindow(Draw)){
			if (ev.xbutton.button == 1) ret = 1;
			if (ev.xbutton.button == 3) ret = -1;
			}
		if( ev.xbutton.window == XtWindow(Menu[ROLLRIGHT])){
			g_cls();
			ret = 2;
			Move_org(Draw,(XtPointer)ROLLRIGHT-ROLLRIGHT,NULL);
			}
		if( ev.xbutton.window == XtWindow(Menu[ROLLUP])){
			g_cls();
			ret = 2;
			Move_org(Draw,(XtPointer)ROLLUP-ROLLRIGHT,NULL);
			}
		if( ev.xbutton.window == XtWindow(Menu[ROLLDOWN])){
			g_cls();
			ret = 2;
			Move_org(Draw,(XtPointer)ROLLDOWN-ROLLRIGHT,NULL);
			}
		if( ev.xbutton.window == XtWindow(Menu[ROLLLEFT])){
			g_cls();
			ret = 2;
			Move_org(Draw,(XtPointer)ROLLLEFT-ROLLRIGHT,NULL);
			}
		break;
	case MotionNotify:
		_x = ev.xmotion.x;
		_y = ev.xmotion.y;
		break;
	}

	restrict(&_x,&_y);
	*x = _x; *y = _y;
	return ret;
}

global	selecting_box(int x1,int y1,int *x,int *y)
{
	int	ox,oy,px,py,mx,my;
	int	ret;

beginloop:	;
	px = mx = ox = x1-org_x;
	py = my = oy = y1-org_y;
	for (;;) {
		if ((px!=mx)||(py!=my)) {
			sel_box(ox,oy,px,py);
			sel_box(ox,oy,mx,my);
			px = mx;
			py = my;
		}
		if ((ret=restrictmouse(&mx,&my))==2)
			goto beginloop;			/* mov_org */
		gridmouse(&mx,&my);
		if (ret == 0)
			continue;
		if (ret > 0) {
			*x = mx+org_x;
			*y = my+org_y;
			ret = CRSUCCESS;
			break;
		}
		if (ret < 0) {
			ret = CRNONE;
			break;
		}
	}
	sel_box(ox,oy,px,py);
	return ret;
}

/********************************
*	drawing functions	*
*********************************/

struct DD {
	int	r;
	int	d;
};

struct LN {
	int	l;
	int	dx,dy;
	int	d;
};

typedef struct __PACKET {
	struct XY	o;
	union {
		struct XY	e;
		struct DD	c;
		struct LN	l;
	} b;
	int (*draw)(int,int,struct __PACKET *);
	int (*replace)(int,int,struct __PACKET *);
	int (*delete)(int,int,struct __PACKET *);
} PACKET;

typedef	int	(*PFV_iip)(int, int,PACKET *);

static int	drawing_obj(int x1,int y1,PACKET *p)
{
	int	ox,oy,px,py,mx,my;
	int	ret;

beginloop:	;
	mx = x1 - org_x;
	my = y1 - org_y;
	(*(p->draw))(x1,y1,p);
	for (;;) {
		(*(p->replace))(mx,my,p);
		if ((ret=restrictmouse(&mx,&my))==2)
			goto beginloop;			/* mov_org */
		if (ret == 0)
			continue;
		if (ret > 0) {
			ret = CRSUCCESS;
			break;
		}
		if (ret < 0) {
			ret = CRNONE;
			break;
		}
	}
	(*(p->delete))(mx,my,p);
	return ret;
}

static int	draw_box_sub(int x1,int y1,PACKET *p)
{
	p->b.e.x = p->o.x = x1-org_x;
	p->b.e.y = p->o.y = y1-org_y;
}

static int	replace_box_sub(int mx,int my,PACKET *p)
{
	gridmouse(&mx,&my);
	if ((p->b.e.x!=mx)||(p->b.e.y!=my)) {
		dx_box(p->o.x,p->o.y,p->b.e.x,p->b.e.y);
		p->b.e.x = mx;
		p->b.e.y = my;
		dx_box(p->o.x,p->o.y,p->b.e.x,p->b.e.y);
	}
}

static int	delete_box_sub(int mx,int my,PACKET *p)
{
	gridmouse(&mx,&my);
	dx_box(p->o.x,p->o.y,p->b.e.x,p->b.e.y);
	p->o.x +=org_x;
	p->o.y +=org_y;
	p->b.e.x = mx+org_x;
	p->b.e.y = my+org_y;
}

global	drawing_box(int x1,int y1,int *x,int *y)
{
	int	ret;
	PACKET	pack;

	pack.draw	=(PFV_iip)draw_box_sub;
	pack.replace	=(PFV_iip)replace_box_sub;
	pack.delete	=(PFV_iip)delete_box_sub;
	ret = drawing_obj(x1,y1,&pack);
	*x = pack.b.e.x;
	*y = pack.b.e.y;
	return ret;
}

static int	draw_circle_sub(int x1,int y1,PACKET *p)
{
	p->o.x = x1-org_x;
	p->o.y = y1-org_y;
	p->b.c.r = 0;
}

static int	replace_circle_sub(int mx,int my,PACKET *p)
{
	int	r;

	r = (int)l2norm(p->o.x-mx,p->o.y-my);
	r = ((r+p->b.c.d/2)/p->b.c.d) * p->b.c.d;
	if (p->b.c.r!=r) {
		dx_circle(p->o.x,p->o.y,p->b.c.r);
		p->b.c.r = r;
		dx_circle(p->o.x,p->o.y,p->b.c.r);
	}
}

static int	delete_circle_sub(int mx,int my,PACKET *p)
{
	int	r;

	r = (int)l2norm(p->o.x-mx,p->o.y-my);
	r = ((r+p->b.c.d/2)/p->b.c.d) * p->b.c.d;
	dx_circle(p->o.x,p->o.y,p->b.c.r);
	p->o.x +=org_x;
	p->o.y +=org_y;
	p->b.c.r = r;
}

global	drawing_circle(int type,int x1,int y1,int *rp)
{
	int	ret;
	PACKET	pack;

	if	(type == CIRCLETYPE)	pack.b.c.d = grid;
	else if	(type == CIRCSTTYPE)	pack.b.c.d = 2;
	else				return CRNONE;

	pack.draw	=(PFV_iip)draw_circle_sub;
	pack.replace	=(PFV_iip)replace_circle_sub;
	pack.delete	=(PFV_iip)delete_circle_sub;
	ret = drawing_obj(x1,y1,&pack);
	*rp = pack.b.c.r;
	return ret;
}

global	drawing_line(int type,int x1,int y1,
		int *x,int *y,int *dir_x,int *dir_y,int *len)
{
	int	ox,oy,px,py,mx,my;
	int	ret,n;

	if (type == LINETYPE)
		n = 7;
	else if (type == ARROWTYPE)
		n = 5;
	else
		return CRNONE;
beginloop:	;
	px = mx = ox = x1-org_x;
	py = my = oy = y1-org_y;
	for (;;) {
		if ((px!=mx)||(py!=my)) {
			dx_line(ox,oy,px,py);
			dx_line(ox,oy,mx,my);
			px = mx;
			py = my;
		}
		if ((ret = restrictmouse(&mx,&my))==2)
			goto beginloop;		/* mov_org */
		linexy(n,ox,oy,mx,my,dir_x,dir_y,&mx,&my);
		if (ret==0)
			continue;
		if (ret > 0) {
			*x = mx+org_x;
			*y = my+org_y;
			*len = ((ox==mx)? abs(oy-my): abs(ox-mx));
			ret = CRSUCCESS;
			break;
		}
		if (ret < 0) {
			ret = CRNONE;
			break;
		}
	}
	dx_line(ox,oy,px,py);
	return ret;
}

/****************************************
*	moving object functions		*
*****************************************/

static int	m_width,m_height,m_radius;

static int	m_dr_box(int x,int y) {dx_box(x,y,x+m_width,y+m_height);}

static int	m_dl_box(int x,int y) {dx_box(x,y,x+m_width,y+m_height);}

static int	m_dr_line(int x,int y) {dx_line(x,y,x+m_width,y+m_height);}

static int	m_dl_line(int x,int y) {dx_line(x,y,x+m_width,y+m_height);}

static int	m_dr_circle(int x,int y) {dx_circle(x,y,m_radius);}

static int	m_dl_circle(int x,int y) {dx_circle(x,y,m_radius);}

typedef	int	(*PFV)(int, int);

static int	moving_picture(PFV dr_fun,PFV dl_fun,int x1,int y1,int *dx,int *dy)
{
	int	px,py,x,y;
	int	ret;

	x = x1 - org_x;
	y = y1 - org_y;
beginloop:	;
	px = x;
	py = y;
	(*dr_fun)(x,y);
	for (;;) {
		if ((px!=x)||(py!=y)) {
			(*dl_fun)(px,py);
			(*dr_fun)(x,y);
			px = x;
			py = y;
		}
		ret = restrictmouse(&x,&y);
		gridmouse(&x,&y);
		if (ret==0)			/* no click */
			continue;
		if (ret==2)			/* mov_org */
			goto beginloop;
		if (ret > 0) {			/* confirm */
			ret = CRSUCCESS;
			*dx = x+org_x-x1;
			*dy = y+org_y-y1;
			break;
		}
		if (ret < 0) {			/* cancel */
			ret = CRNONE;
			break;
		}
	}
	(*dl_fun)(px,py);
	return ret;
}

global	moving_box(int x1,int y1,int w,int h,int *dx,int *dy)
{
	m_width	 = w;	m_height = h;
	return moving_picture(m_dr_box,m_dl_box,x1,y1,dx,dy);
}

global	moving_circle(int x1,int y1,int r,int *dx,int *dy)
{
	m_radius = r;
	return moving_picture(m_dr_circle,m_dl_circle,x1,y1,dx,dy);
}

global	moving_line(int x1,int y1,int w,int h,int *dx,int *dy)
{
	m_width	 = w;	m_height = h;
	return moving_picture(m_dr_line,m_dl_line,x1,y1,dx,dy);
}

/********************************
*	draw functions		*
*********************************/

static	drstrmark(int pos,int lx,int by,int rx,int ty)
{
	int	cx,cy;
	int	x1,y1,x2,y2,x3,y3;

	cx = (rx+lx)/2;
	cy = (ty+by)/2;
	lx += 1;
	rx -= 1;
	by -= 1;
	ty += 1;
	if (pos==5) {	/* center */
			dr_box(cx-4,cy-4,cx+4,cy+4);
			dr_line(cx-4,cy-4,cx+4,cy+4);
			dr_line(cx-4,cy+4,cx+4,cy-4);
			return;
	}
	else if (pos==1) {	/* bottom left */
			x1 = lx;	x2 = lx;	x3 = lx+4;
			y1 = by;	y2 = by-4;	y3 = by;
	}
	else if (pos==2) {	/* bottom */
			x1 = cx-4;	x2 = cx+4;	x3 = cx;
			y1 = by-4;	y2 = y1;	y3 = by;
	}
	else if (pos==3) {	/* bottom right */
			x1 = rx;	x2 = rx;	x3 = rx-4;
			y1 = by;	y2 = by-4;	y3 = by;
	}
	else if (pos==4) { /* left */
			x1 = lx+4;	x2 = x1;	x3 = lx;
			y1 = cy-4;	y2 = cy+4;	y3 = cy;
	}
	else if (pos==6) {	/* right */
			x1 = rx-4;	x2 = x1;	x3 = rx;
			y1 = cy-4;	y2 = cy+4;	y3 = cy;
	}
	else if (pos==7) { /* top left */
			x1 = lx;	x2 = lx;	x3 = lx+4;
			y1 = ty;	y2 = ty+4;	y3 = ty;
	}
	else if (pos==8) { /* top */
			x1 = cx-4;	x2 = cx+4;	x3 = cx;
			y1 = ty+4;	y2 = y1;	y3 = ty;
	}
	else if (pos==9) { /* top right */
			x1 = rx;	x2 = rx;	x3 = rx-4;
			y1 = ty;	y2 = ty+4;	y3 = ty;
	}
	dr_line(x1,y1,x2,y2);
	dr_line(x2,y2,x3,y3);
	dr_line(x3,y3,x1,y1);
}

static	draw_framebox(OBJ *obj)
{
	int	lx,rx,ty,by;

	lx = obj->x-org_x;	rx = obj->x-org_x+obj->body.framebox.w;
	by = obj->y-org_y;	ty = obj->y-org_y-obj->body.framebox.h;
	if (obj->type == FRAMEBOXTYPE)
		dr_box(lx,by,rx,ty);
	else if(obj->type == DASHBOXTYPE)
		ds_box(lx,by,rx,ty);
	drstrmark(obj->body.framebox.pos,lx,by,rx,ty);
}

static	draw_circle(OBJ *obj)
{
	int	cx,cy;

	cx = obj->x-org_x;	cy = obj->y-org_y;
	if (obj->type==CIRCLETYPE)
		dr_circle(cx,cy,obj->body.circle.di/2);
	else
		dr_circst(cx,cy,obj->body.circ.di/2);
}

static	draw_line(OBJ *obj)
{
	int	cx,cy,x,y;

	linexy2(cx =	obj->x - org_x,
		cy =	obj->y - org_y,
			obj->body.line.dir_x,
			obj->body.line.dir_y,
			obj->body.line.len,
		&x,&y);
	dr_line(cx,cy,x,y);
	if (obj->type==ARROWTYPE) {
		int	xr,yr,xl,yl;

		arrowrl(cx,cy,x,y,&xr,&yr,&xl,&yl);
		dr_line(x,y,xr,yr);
		dr_line(x,y,xl,yl);
	}
}

/********************************
*	moving function		*
*********************************/

global	moving_grpbox(int sx,int sy,BOXPOS *box,int *dx,int *dy)
{
	int	px,py,x,y,w,h,ox,oy;
	int	ret;

	x = box->x1-org_x;
	y = box->y1-org_y;
	w = box->x2 - box->x1;
	h = box->y2 - box->y1;
beginloop:	;
	ox = sx - org_x;
	oy = sy - org_y;
	px = x;	py = y;
	sel_box(x,y,x+w,y+h);
	for (;;) {
		if ((px!=x)||(py!=y)) {
			sel_box(px,py,px+w,py+h);
			sel_box(x,y,x+w,y+h);
			px = x;
			py = y;
		}
		if ((ret=restrictmouse(&x,&y))==2)	/* mov_org */
			goto beginloop;
		*dx = ((x-ox)/grid)*grid;
		*dy = ((y-oy)/grid)*grid;
		x = box->x1-org_x+*dx;
		y = box->y1-org_y+*dy;
		if (ret==0)
			continue;
		if (ret > 0) {
			ret = CRSUCCESS;
			break;
		}
		if (ret < 0) {	/* if cancel */
			ret = CRNONE;
			break;
		}
	}
	sel_box(px,py,px+w,py+h);
	return ret;
}


/********************************
*	draw & hide functions	*
*********************************/

typedef	int	(*DRFUN)(OBJ *);

global	redrawobj(OBJ *obj)
{
	static DRFUN	drawfunc[]={
		draw_framebox,
		draw_framebox,
		draw_framebox,
		draw_line,
		draw_line,
		draw_circle,
		draw_circle
	};

	(*drawfunc[obj->type-FRAMEBOXTYPE])(obj);
}

global	redrawgrp(GRP *grp)
{
	ICELL *st;

	for (st = grp->first; st!=NULL; st=st->succ)
		redrawobj(st->obj);
}

global	hidegrp(GRP *grp)
{
	GRP	*succ;

	hidegrpbx(grp);
	succ = scr.group;
	while (succ != NULL) {
		if ((succ!=grp)&&(overbox(&grp->box,&succ->box)))
			redrawgrp(succ);
		succ = succ->succ;
	}
}

global	redrawbox(BOXPOS *bp)
{
	GRP	*grp;
	ICELL	*icl;

	for (grp = scr.group; grp!=NULL; grp=grp->succ)
		if (overbox(&(grp->box),bp))
			for (icl=grp->first; icl!=NULL; icl=icl->succ)
				if(overbox(&(icl->obj->box),bp))
					redrawobj(icl->obj);
}
