#include "pe.h"
#include "glio.h"

extern selobj(int),left_release_wait(), gridmouse(int *, int *);

static FILE	*fp;

static BOXPOS	savebox;

itoa(int d,char *s,int i) {sprintf(s,"%d",d);}

static int fputch(char c) { fputc(c,fp); }

static int fputstr(char *s) { fputs(s,fp); }

static fputd(int d)
{
	char	s[8];

	itoa(d,s,10);
	fputstr(s);
}

static fputxy(int x,int y)
{fputch('(');fputd(x);fputch(',');fputd(y);fputch(')'); }

static fputn(int n) {fputch('{'); fputd(n); fputch('}'); }

static char *strpos[] = {
	"[bl]",	"[b]",	"[br]",	"[l]",	"",
	"[r]",	"[tl]",	"[t]",	"[tr]",
};

static int	divide_region()
{
	int	x1,y1,x2,y2;
	XEvent ev;

	for (;;) {
		do{
			XNextEvent(XtDisplay(Draw),&ev);
		}while(ev.type != ButtonPress);

		x1 = ev.xbutton.x;
		y1 = ev.xbutton.y;
		if( ev.xbutton.window == XtWindow(Draw)){
			if (ev.xbutton.button == 1) {
				x1 += org_x ;
				y1 += org_y ;
				break;
				}
			if (ev.xbutton.button == 3) return CRNONE;
			}
		if( ev.xbutton.window == XtWindow(Menu[ROLLUP])){
			g_cls();
			Move_org(Draw,(XtPointer)ROLLRIGHT-ROLLRIGHT,
								NULL);
			}
		if( ev.xbutton.window == XtWindow(Menu[ROLLUP])){
			g_cls();
			Move_org(Draw,(XtPointer)ROLLUP-ROLLRIGHT,
								NULL);
			}
		if( ev.xbutton.window == XtWindow(Menu[ROLLDOWN])){
			g_cls();
			Move_org(Draw,(XtPointer)ROLLDOWN-ROLLRIGHT,
								NULL);
			}
		if( ev.xbutton.window == XtWindow(Menu[ROLLLEFT])){
			g_cls();
			Move_org(Draw,(XtPointer)ROLLLEFT-ROLLRIGHT,
								NULL);
			}
	}

	left_release_wait();
	gridmouse(&x1,&y1);

	if (selecting_box(x1,y1,&x2,&y2)==CRNONE)
		return CRNONE;

	boxpos(&savebox,x1,y1,x2,y2);
	return CRSUCCESS;
}

/********************************
*	PROLOGUE & EPILOGUE	*
*********************************/

static int	headout()
{
	static char	*headmessage[]={
		"%\n%\tIf undefined \\picture, input \"picture.tex.\"\n%",
		"\n\\let\\bye=\\relax",
		"\n\\expandafter\\ifx\\csname picture\\endcsname\\relax",
		"\n\\input picture \\let\\bye=\\end\\nopagenumbers\\fi",
		"\n%\n%\tSet scale factor\n%\n\\unitlength=0.5pt",
		"\n%\n%\tBEGIN PICTURE MODE\n%",
		"\n\\picture",
		""
	};
	int	i;

	for (i=0; headmessage[i][0]!='\0'; i++)
		fputstr(headmessage[i]);
	fputxy(	savebox.x2-savebox.x1,
		savebox.y2-savebox.y1);
}

static int	footout()
{
	static char	*footmessage[]={
		"\n\\endpicture",
		"\n%\n%\tEND PICTURE MODE\n%",
		"\n\\bye\n"
	};
	int	i;

	for (i=0; i<3; i++)
		fputstr(footmessage[i]);
}

/****************************************
*	Primitive Output Routines	*
*****************************************/

static int	prnboxtypeobj(OBJ *obj,char *boxtype)
{
	char	*s;

	s = strpos[obj->body.framebox.pos-1];
	fputstr("\n\\put");
	fputxy(	obj->x-savebox.x1,
		savebox.y2-obj->y);
	fputstr(boxtype);
	fputxy(	obj->body.framebox.w,obj->body.framebox.h);
	fputstr(s);
	fputch('{'); fputstr(obj->body.framebox.s); fputch('}');
	fputch('}');
}

static int prnframebox(OBJ *obj) {prnboxtypeobj(obj,"{\\framebox");}

static int prndashbox(OBJ *obj) {prnboxtypeobj(obj,"{\\dashbox{5}");}

static int prnmakebox(OBJ *obj) {prnboxtypeobj(obj,"{\\makebox");}

static int	prncircletypeobj(OBJ *obj,char *s)
{
	fputstr("\n\\put");
	fputxy(	obj->x-savebox.x1,
		savebox.y2-obj->y);
	fputstr("{\\circle");
	fputstr(s);
	fputn(obj->body.circle.di);
	fputch('}');
}

static int prncircle(OBJ *obj) {prncircletypeobj(obj,"");}

static int prncircst(OBJ *obj) {prncircletypeobj(obj,"*");}

static int prnlinetypeobj(OBJ *obj,char *s)
{
	fputstr("\n\\put");
	fputxy(	obj->x-savebox.x1,
		savebox.y2-obj->y);
	fputstr(s);
	fputxy(	obj->body.line.dir_x,
		obj->body.line.dir_y);
	fputn(	obj->body.line.len);
	fputch('}');
}

static int prnline(OBJ *obj) {prnlinetypeobj(obj,"{\\line");}

static int prnarrow(OBJ *obj) {prnlinetypeobj(obj,"{\\vector");}

/****************************************
*	Group & Object Output Routines	*
*****************************************/

typedef	int	(*PRNFUNC)(OBJ *);

static int	prndata(OBJ *obj)
{
	static PRNFUNC	prnfunc[]={
		prnframebox,
		prndashbox,
		prnmakebox,
		prnline,
		prnarrow,
		prncircle,
		prncircst
	};

	if (boxinbox(obj->box,savebox))
		(*prnfunc[obj->type-FRAMEBOXTYPE])(obj);
}

static int	dataout()
{
	GRP	*grp;
	ICELL	*icl;

	for (grp = scr.group; grp!=NULL; grp = grp->succ)
		for (icl = grp->first; icl!=NULL; icl = icl->succ)
			prndata(icl->obj);
}

/********************************
*	Global function		*
*********************************/

void fileout(Widget w,XtPointer client_data,XtPointer call_data)
{
	char s[MAXLEN];

	selobj(FILEO);

	if (divide_region()==CRNONE){
		selobj(mode);
		return;}

	if(scr_filename[0] != '\0') strcpy(s,scr_filename);
	getfilename(s);

	if (s[0]=='\0'){
		selobj(mode);
		return;}
	if ((fp=fopen(s,"w"))==NULL){
		selobj(mode);
		return;}
	headout();
	dataout();
	footout();
	fclose(fp);
	modified = 1;
	selobj(mode);
}
