#include <string.h>
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#define	global

#include "glio.h"
#include "popup.h"

#define MAXLEN	MAXPATHLEN

char textdata[MAXLEN];
int selected;

char workdir[MAXPATHLEN];

TextPopup(char *s)
{
	Window rt,ch;
	int rx,ry,wx,wy;
	unsigned int state;

	textdata[0] = '\0';

	XQueryPointer(XtDisplay(Draw),XtWindow(Draw),
				&rt,&ch,&rx,&ry,&wx,&wy,&state);
	if (rx < 160) rx = 160;
	if (rx > 850) rx = 850;
	if (ry > 800) ry = 800;

	XtVaSetValues(textPopup, XtNx, rx - fwidth * 30, XtNy, ry, NULL);
	XtVaSetValues(textDialog, XtNstring, s, XtNwidth,
				fwidth * 60, XtNheight, fheight + 5, NULL);

	XtPopup(textPopup, XtGrabNone);
	XtSetKeyboardFocus(textPopup, textDialog);
	XWarpPointer(XtDisplay(textPopup),None,
			XtWindow(textDone),0,0,0,0,10,10);
}

void textdata_set(Widget w, XtPointer client_data, XtPointer call_data)
{
	String string;

	XtVaGetValues(textDialog, XtNstring, &string, NULL);
	strcpy(textdata, string);
	selected = 1;
	XtPopdown(textPopup);
}

void textdata_set2(Widget w,XEvent *event,String *params,Cardinal *num_params)
{
	textdata_set(w,nametext,NULL);
}

void textdata_cancel(Widget w, XtPointer client_data, XtPointer call_data)
{
	textdata[0]= '\0';
	selected = 1;
	XtPopdown(textPopup);
}

void textdata_cancel2(Widget w,XEvent *event,String *params,Cardinal *num_params)
{
	textdata_cancel(w,nametext,NULL);
}

/********************************
*	Miscellanous Functions	*
*********************************/

global iskanji(unsigned char c)
{
	return 0;
}

/************************
*	get string	*
*************************/

global	getstring(char *s)
{
	int	ret;

	textdata[0]='\0';
	selected = 0;
	TextPopup(s);

  	while (selected == 0) {
      		XEvent event;
      		XtAppNextEvent(app_con,&event);
      		XtDispatchEvent(&event);
	}

	if ( textdata[0] == '\0') return -1;
	strcpy(s,textdata);
	return 0;
}

extern getcwdls();

FilePopup()
{
	Position rx,ry;

	XtVaGetValues(toplevel, XtNx, &rx, XtNy, &ry, NULL);
	XtVaSetValues(filePopup, XtNx, rx + 100, XtNy, ry + 50, NULL);

	XtPopup(filePopup, XtGrabNone);
	filelistset();
	XtSetKeyboardFocus(filePopup, nametext);
	XWarpPointer(XtDisplay(filePopup),None,
			XtWindow(namedone),0,0,0,0,10,10);
}

filelistset()
{
	int nfiles;
	String *filename;
	
	filename = (String *)getcwdls(&nfiles);

	if(textdata[0] != '\0'){
		XtVaSetValues(nametext, XtNlength, MAXPATHLEN,
						XtNstring, textdata, NULL);
		textdata[0] = '\0';
	} else XtVaSetValues(nametext, XtNlength, MAXPATHLEN,
						XtNstring, workdir, NULL);
	XawViewportSetLocation(nameview, 0.0, 0.0);

	XtVaSetValues(namelist, XtNlist, filename,
		XtNnumberStrings,nfiles, XtNforceColumns,TRUE,
		XtNcolumnSpacing,80, NULL);
}

void namesetdone(Widget w, XtPointer client_data, XtPointer call_data)
{
	char *buf,cmp[MAXLEN],slnk[MAXLEN];
	int l;
	struct stat sbuf;

	XtVaGetValues((Widget)client_data, XtNstring, &buf, NULL);
	
	strcpy(cmp, workdir);
	strcat(cmp,".");
	if(strncmp(buf,cmp,MAXLEN) == 0) {
		XtVaSetValues(nametext, XtNstring, workdir, NULL); 
		return;
	}

	strcpy(cmp, workdir);
	strcat(cmp,"..");
	if(strncmp(buf,cmp,MAXLEN) == 0) {
		if(workdir[1] == '\0') {
			XtVaSetValues(nametext,XtNstring,workdir,NULL);
			return;
		}
		l = strlen(workdir) - 2;
		while(workdir[l] != '/') {
			workdir[l] = '\0';
			l--;
		}
		filelistset();
		return;
	}
			
	stat(buf, &sbuf);

	if(S_ISLNK(sbuf.st_mode)){
		l = readlink(buf,slnk,MAXLEN);
		slnk[l] = '\0';
		if(slnk[0] == '/') strcpy(buf,slnk);
			else {
			while(slnk[l] != '/') {
				slnk[l] = '\0';
				l--;
			}
			strcat(buf,slnk);
			}
		stat(buf, &sbuf);
		if(S_ISDIR(sbuf.st_mode)) strcat(buf,"/");
		}

	if(S_ISDIR(sbuf.st_mode)){
		if(access(buf,X_OK) == -1) {
			XtVaSetValues(nametext,XtNstring,workdir,NULL);
			return;
		}
		if(buf[strlen(buf)-1] != '/') strcat(buf,"/");
		strcpy(workdir,buf);
		filelistset();
		return;
	}
		strcpy(textdata,buf);
		XtPopdown(filePopup);
		selected = 1;
}

void namesetdone2(Widget w,XEvent *event,String *params,Cardinal *num_params)
{
	namesetdone(w,nametext,NULL);
}

void namesel(Widget w, XtPointer client_data, XtPointer call_data)
{
	char pathname[MAXLEN];
	XawTextPosition end;
	XawTextBlock textblock;
	XawListReturnStruct *list_ret =
		(XawListReturnStruct *)call_data;

	end = MAXLEN;
	strcpy(pathname,workdir);
	strcat(pathname,list_ret->string);
	textblock.firstPos = 0;
	textblock.length = strlen(pathname);
	textblock.ptr = pathname;
	XawTextReplace(nametext, (XawTextPosition)0, end, &textblock);
}

void namesetcancel(Widget w, XtPointer client_data, XtPointer call_data)
{
	textdata[0]= '\0';
	selected = 1;
	XtPopdown(filePopup);
}

void namesetcancel2(Widget w,XEvent *event,String *params,Cardinal *num_params)
{
	namesetcancel(w,NULL,NULL);
}

extern	char	scr_filename[];

global	getfilename(char *s)
{
	int	ret;

	textdata[0]='\0';
	if(scr_filename[0] != '\0') strcpy(textdata,scr_filename);
	selected = 0;
	FilePopup();

  	while (selected == 0) {
      		XEvent event;
      		XtAppNextEvent(app_con,&event);
      		XtDispatchEvent(&event);
	}

	if ( textdata[0] == '\0') return -1;
	strcpy(s,textdata);
	return 0;
}
