#include	"pe.h"
#include	"glio.h"
#include 	"button.h"
#include 	"cursor.h"

extern int InitTextPopup(), InitQuitPopup(),InitFilePopup();

void	RedrawPicture(Widget w,XEvent *event,String *params,Cardinal *num_params)
{
	GRP	*grp;
	Dimension wd, hi;

	XtVaGetValues(Draw, XtNwidth, &wd, XtNheight, &hi, NULL);
	
	drwidth = (int)wd;
	drheight = (int)hi;

	MakeGrid();
	MakeButton();

	for (grp=scr.group; grp!=NULL; grp=grp->succ)
		redrawgrp(grp);
}

/**/
/**
*
* NAME		g_init - initialization of Widget 
*
* SYNOPSIS	ret = g_init();
*		int ret;	return condition
*
**/

void DrawPicture();
extern void namesetdone2(),namesetcancel2();
extern void textdata_set2(),textdata_cancel2();

static XtActionsRec actions[] =
{
	{"DrawPicture",	DrawPicture},
	{"RedrawPicture",RedrawPicture},
	{"namesetdone2",namesetdone2},
	{"namesetcancel2",namesetcancel2},
	{"textdata_set2",textdata_set2},
	{"textdata_cancel2",textdata_cancel2},
};

static String MenuName[] =
	{"","Quit","Open","Save","Undel","Delete",
	 "Resize","Text Edit","Move","Copy","Group","UnGroup"};

static String ResName[] =
	{"Draw","Quit","Open","Save","Undel","Delete",
	 "ReSize","TextEdit","Move","Copy","Group","UnGroup",
	 "FrameBox","DashBox","MakeBox","Line","Arrow","Circle",
	 "CircleFill","RollRight","RollLeft","RollUp","RollDown"};

static	char sel_dash[]={1,1};
static	char dash_dash[]={4,4};

int	g_init()
{
	int i,n;
	BOXPOS *bp;
	Pixel fgc,bgc;
	XFontStruct *fs;
	unsigned int lwd, rht;
	Dimension dim;

	extern void mode_change(Widget, XtPointer, XtPointer);
	extern void Move_org(Widget, XtPointer, XtPointer);
	extern void Quit(Widget, XtPointer, XtPointer);
	extern void filein(Widget, XtPointer, XtPointer);
	extern void fileout(Widget, XtPointer, XtPointer);
	extern void undelgrp(Widget, XtPointer, XtPointer);

	Vpaned = XtVaCreateManagedWidget("vpaned",
			formWidgetClass ,toplevel,NULL);

	Menu[ROLLUP] = XtVaCreateManagedWidget(ResName[ROLLUP],
		commandWidgetClass,Vpaned,XtNlabel,"",NULL);
	XtAddCallback(Menu[ROLLUP],XtNcallback,Move_org,
				(XtPointer)(ROLLUP-ROLLRIGHT));

	Menu[ROLLLEFT] = XtVaCreateManagedWidget(ResName[ROLLLEFT],
		commandWidgetClass,Vpaned,
		XtNfromVert,Menu[ROLLUP],XtNlabel,"",NULL);
	XtAddCallback(Menu[ROLLLEFT],XtNcallback,Move_org,
				(XtPointer)(ROLLLEFT-ROLLRIGHT));

	Draw= XtVaCreateManagedWidget("draw",boxWidgetClass,Vpaned,
			XtNfromVert,Menu[ROLLUP],
			XtNfromHoriz,Menu[ROLLLEFT],NULL);

	Menu[ROLLDOWN] = XtVaCreateManagedWidget(ResName[ROLLDOWN],
		commandWidgetClass,Vpaned,
		XtNfromVert,Draw,XtNlabel,"",NULL);
	XtAddCallback(Menu[ROLLDOWN],XtNcallback,Move_org,
				(XtPointer)(ROLLDOWN-ROLLRIGHT));

	Menu[ROLLRIGHT] = XtVaCreateManagedWidget(ResName[ROLLRIGHT],
		commandWidgetClass,Vpaned,
		XtNfromVert,Menu[ROLLUP],
		XtNfromHoriz,Draw,XtNlabel,"",NULL);
	XtAddCallback(Menu[ROLLRIGHT],XtNcallback,Move_org,
				(XtPointer)(ROLLRIGHT-ROLLRIGHT));

	Menu[QUIT] = XtVaCreateManagedWidget(ResName[QUIT],
			commandWidgetClass,Vpaned,NULL);
	XtAddCallback(Menu[QUIT],XtNcallback,Quit,NULL);

	XtVaGetValues(Menu[QUIT], XtNfont, &fs, NULL);
	fwidth = fs->max_bounds.width;
	fheight = fs->max_bounds.ascent + fs->max_bounds.descent;
	lwd = fwidth*10;

	XtVaSetValues(Menu[QUIT], XtNwidth, lwd, NULL);
	XtVaGetValues(Draw, XtNwidth, &dim, NULL); drwidth = (int)dim + 12;
	XtVaGetValues(Menu[ROLLRIGHT], XtNwidth, &dim, NULL); rht = (int)dim;
	XtVaGetValues(Menu[ROLLLEFT], XtNwidth, &dim, NULL); rht += (int)dim;
	XtVaSetValues(Menu[ROLLUP], XtNwidth, (Dimension)(drwidth+rht), NULL);
	XtVaSetValues(Menu[ROLLDOWN], XtNwidth, (Dimension)(drwidth+rht), NULL);

	Menu[FILEI] = XtVaCreateManagedWidget(ResName[FILEI],
			commandWidgetClass,Vpaned,XtNwidth,lwd,NULL);
	XtAddCallback(Menu[FILEI],XtNcallback,filein,NULL);
	
	Menu[FILEO] = XtVaCreateManagedWidget(ResName[FILEO],
			commandWidgetClass,Vpaned,XtNwidth,lwd,NULL);
	XtAddCallback(Menu[FILEO],XtNcallback,fileout,NULL);

	Menu[UNDEL] = XtVaCreateManagedWidget(ResName[UNDEL],
			commandWidgetClass,Vpaned,XtNwidth,lwd,NULL);
	XtAddCallback(Menu[UNDEL],XtNcallback,undelgrp,NULL);

	for(i=DELETE;i<FRAMEBOXTYPE;i++){
		Menu[i] = XtVaCreateManagedWidget(ResName[i],
				commandWidgetClass,Vpaned,
				XtNlabel,MenuName[i],XtNwidth,lwd,NULL);
		XtAddCallback(Menu[i],XtNcallback,mode_change,
							(XtPointer)i);
	}

	for(i=FRAMEBOXTYPE;i<ROLLRIGHT;i++){
		Menu[i] = XtVaCreateManagedWidget(ResName[i],
				commandWidgetClass,Vpaned,NULL);
		XtAddCallback(Menu[i],XtNcallback,mode_change,
							(XtPointer)i);
	}

	XtVaGetValues(Menu[FRAMEBOXTYPE], XtNheight, &dim, NULL);
	drheight = (fheight + 10) * 11 + ((int)dim + 4) * 4 - rht - 10;
	XtVaGetValues(Draw, XtNheight, &dim, NULL);
	if(drheight > (int)dim) XtVaSetValues(Draw, XtNheight, drheight, NULL);
		else drheight = (int)dim;
	XtVaSetValues(Menu[ROLLLEFT], XtNheight, drheight, NULL);
	XtVaSetValues(Menu[ROLLRIGHT], XtNheight, drheight, NULL);

	InitTextPopup();
	InitQuitPopup();
	InitFilePopup();

	XtAppAddActions(app_con, actions, XtNumber(actions));
	XtAddEventHandler(Draw,PointerMotionHintMask,FALSE,NULL,NULL);

	XtRealizeWidget(toplevel);

	CreateGC();
	MakeCursor();
}

MakeButton()
{
	int i, n;
	Pixel fgc, bgc;
	Pixmap pixmap;
	
	for(i=FRAMEBOXTYPE;i<=CIRCSTTYPE;i++){
		XtVaGetValues(Menu[i], XtNforeground, &fgc,
				XtNbackground, &bgc, NULL);

		pixmap = XCreatePixmapFromBitmapData(XtDisplay(Menu[i]),
			XtWindow(Menu[i]),butpattern[i-FRAMEBOXTYPE],
			(unsigned int)32,(unsigned int)32,fgc,bgc,
			DefaultDepth(XtDisplay(Menu[i]),0));
		XtVaSetValues(Menu[i], XtNbitmap, pixmap,NULL);
		}
}

MakeCursor()
{
	int	i,hp;
	Display	*d;
	Pixmap	pixmap;
	XColor	cl;
	Cursor	cs;
/*	Pixel	fgc;*/
	
	d = XtDisplay(Draw);
/*	XtVaGetValues(Draw, XtNforeground, &fgc, NULL);
	cl.pixel = (unsigned long)fgc;
*/	cl.pixel = BlackPixel(d,0);
	XQueryColor(d, DefaultColormap(d,0), &cl);
	for(i=0;i<C_CIRST+1;i++){
		pixmap = XCreateBitmapFromData(d, XtWindow(Draw),
			cursor_pattern[i],(unsigned int)16,(unsigned int)16);
		if(i < C_FRAME) hp = 0; else hp = 15;
		Mode_Cursor[i] = XCreatePixmapCursor(d,pixmap,
						pixmap,&cl,&cl,0,hp);
	}

	Cursor_Mode[QUIT] = C_FRAME;
	for(i=FILEI;i<UNDEL;i++) Cursor_Mode[i] = C_FILE;
	Cursor_Mode[UNDEL] = C_FRAME;
	for(i=DELETE;i<ROLLRIGHT;i++) Cursor_Mode[i] = i - 4;
}

CreateGC()
{
	Pixel fgc, bgc, xorc;

	XtVaGetValues(Menu[ROLLUP], XtNforeground, &fgc,
		XtNbackground, &bgc, NULL);
	xorc = fgc;

	if((bgc)^(fgc) == bgc) xorc = bgc;

	gc = XCreateGC(XtDisplay(Draw),XtWindow(Draw),0,0);
	XSetForeground(XtDisplay(Draw),gc,fgc);

	del_gc = XCreateGC(XtDisplay(Draw),XtWindow(Draw),0,0);
	XSetForeground(XtDisplay(Draw),del_gc,bgc);

	sel_gc = XCreateGC(XtDisplay(Draw),XtWindow(Draw),0,0);
	XSetForeground(XtDisplay(Draw),sel_gc,xorc);
	XSetLineAttributes(XtDisplay(Draw),sel_gc,0,
				LineOnOffDash,CapButt,JoinMiter);
	XSetDashes(XtDisplay(Draw),sel_gc,0,sel_dash,2);
	XSetFunction(XtDisplay(Draw),sel_gc,GXxor);

	dash_gc = XCreateGC(XtDisplay(Draw),XtWindow(Draw),0,0);
	XSetForeground(XtDisplay(Draw),dash_gc,fgc);
	XSetLineAttributes(XtDisplay(Draw),dash_gc,0,
				LineOnOffDash,CapButt,JoinMiter);
	XSetDashes(XtDisplay(Draw),dash_gc,0,dash_dash,2);

	xor_gc = XCreateGC(XtDisplay(Draw),XtWindow(Draw),0,0); 
	XSetForeground(XtDisplay(Draw),xor_gc,xorc);
	XSetFunction(XtDisplay(Draw),xor_gc,GXxor);
}

/**
*
* NAME		g_cls  clear Draw Widget
*
* SYNOPSIS	ret = g_cls();
*		int ret;
*
**/

int	g_cls()
{
	XClearWindow(XtDisplay(Draw),XtWindow(Draw));
}

/**/
/**
*
* NAME		g_line  Draw Line on Draw Widget
*
* SYNOPSIS	ret = g_line(x1,y1,x2,y2,dc,lgc)
*		int ret;
*		int x1,y1;
*		int x2,y2;
*		int dc; 0 - Line, 1 - Box, 2 - Fill Box
*		GC lgc; Local Graphic Context
*
**/

int	 g_line(int x1,int y1,int x2,int y2,int dc,GC lgc)
{
	int tmp;

	switch (dc){
	case 1:
	case 2:
		if(x1 > x2) { tmp = x2; x2 = x1; x1 = tmp;}
		if(y1 > y2) { tmp = y2; y2 = y1; y1 = tmp;}
		if(x1 == x2 || y1 == y2) dc = 0;
		break;
	}

	switch (dc) {
	case 0:	XDrawLine(XtDisplay(Draw),XtWindow(Draw),lgc,
							x1,y1,x2,y2);
		break;
	case 1: XDrawRectangle(XtDisplay(Draw),XtWindow(Draw),
					lgc,x1,y1, x2 - x1, y2 - y1);
		break;
	case 2: XFillRectangle(XtDisplay(Draw),XtWindow(Draw),
					lgc,x1,y1, x2 - x1, y2 - y1);
		break;
	}
}

/**/
/**
*
* NAME		g_circle 
*
* SYNOPSIS	ret = g_circle(cx,cy,rx,ry,dc,lgc)
*		int ret;
*		int cx,cy;
*		int rx;	
*		int ry;
*		int dc;
*		GC  lgc;
*
**/

int	 g_circle(int cx,int cy,int rx,int ry,int dc,GC lgc)
{
	switch(dc){
	case 0:	XDrawArc(XtDisplay(Draw),XtWindow(Draw),lgc,
			cx - rx, cy - ry, 2 * rx, 2 * ry,0,64*360);
		break;
	case 1:	XFillArc(XtDisplay(Draw),XtWindow(Draw),lgc,
			cx - rx, cy - ry, 2 * rx, 2 * ry,0,64*360);
		break;
	}
}


#ifdef USEGKANJI
/**/
/**
*
* NAME		g_kanji - print Kanji font
*
* SYNOPSIS	ret = g_kanji(x,y,jap,dm,csw,fc,bc);
*		int ret;	return condition
*		int x,y;	(left, top) coordinate
*		word jap;	kanji code
*		int dm;	 	display mode
*		int csw;	color switch
*		int fc;	 	palette number of the font
*		inc bc;	 	palette number of the other part
*
**/

int	g_kanji(int x,int y,word jap,int dm,int csw,int fc,int bc)
{
}
#endif

int	MakeGrid()
{
int i,j;

	for (i=0; i<drwidth; i+=grid)
		for (j=0; j<drheight; j+=grid)
			XDrawPoint(XtDisplay(Draw),
				XtWindow(Draw),gc,i,j);
	for (i=0; i<drwidth; i+=grid*5)
		for (j=0; j<drheight; j+=grid*5)
			if ((i>0)&&(j>0))
			XFillArc(XtDisplay(Draw),XtWindow(Draw),
					gc,i-2,j-2,4,4,0,64*360);

}

/**
*	end of glio.c
**/
