#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Command.h>
#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Box.h>

typedef unsigned char byte;		/*  byte type definition  */
typedef	unsigned int  word;		/*  word type definiton  */

struct	XY				/*  vertex struct  */
{
	int	x;
	int	y;
};

extern	int		g_init();
extern	int		g_cls();
extern	int		g_pset();
extern	int		g_line();
extern	int		g_circle(int, int, int, int, int, GC);
extern	int		g_kanji(int, int, word, int, int, int, int);

#define C_FILE	0
#define C_DEL	1
#define C_RES	2
#define C_TEXT	3
#define C_MOVE	4
#define C_COPY	5
#define C_GROUP	6
#define C_UNGRP	7
#define C_FRAME	8
#define C_DASH	9
#define C_MBOX	10
#define C_LINE	11
#define C_VEC	12
#define C_CIRC	13
#define C_CIRST	14

#ifdef MAIN_MODULE

Widget toplevel;
Widget Menu[23];
Widget Vpaned,Draw;
Cursor Mode_Cursor[C_CIRST+1];
int    Cursor_Mode[23];	

GC gc,del_gc,sel_gc,dash_gc,xor_gc;

short fwidth, fheight;

XtAppContext	app_con;

static	String fallback_resources[] ={
	"*nametext.translations: #override \\n\
		<Key>Return: namesetdone2()\\n\
		Ctrl<Key>g: namesetcancel2()",
	"*TextDialog.translations: #override \\n\
		<Key>Return: textdata_set2()\\n\
		Ctrl<Key>g: textdata_cancel2()",
	"*draw.translations: #override \\n\
		<Expose>: RedrawPicture()\\n\
		<ResReq>: RedrawPicture()\\n\
		<Btn1Down>: DrawPicture()",
	"*draw.width: 479",
	"*draw.height: 367",
	"*RollUp.height: 12",
	"*RollDown.height: 12",
	"*RollLeft.width: 12",
	"*RollRight.width: 12",
	"*Quit.fromHoriz: RollRight",
	"*Open.fromHoriz: RollRight",
	"*Open.fromVert: Quit",
	"*Save.fromHoriz: RollRight",
	"*Save.fromVert: Open",
	"*Undel.fromHoriz: RollRight",
	"*Undel.fromVert: Save",
	"*Delete.fromHoriz: RollRight",
	"*Delete.fromVert: Undel",
	"*ReSize.fromHoriz: RollRight",
	"*ReSize.fromVert: Delete",
	"*TextEdit.fromHoriz: RollRight",
	"*TextEdit.fromVert: ReSize",
	"*Move.fromHoriz: RollRight",
	"*Move.fromVert: TextEdit",
	"*Copy.fromHoriz: RollRight",
	"*Copy.fromVert: Move",
	"*Group.fromHoriz: RollRight",
	"*Group.fromVert: Copy",
	"*UnGroup.fromHoriz: RollRight",
	"*UnGroup.fromVert: Group",
	"*FrameBox.width: 41",
	"*FrameBox.height: 37",
	"*FrameBox.label: ",
	"*FrameBox.fromHoriz: RollRight",
	"*FrameBox.fromVert: UnGroup",
	"*DashBox.width: 41",
	"*DashBox.height: 37",
	"*DashBox.label: ",
	"*DashBox.fromHoriz: FrameBox",
	"*DashBox.fromVert: UnGroup",
	"*MakeBox.width: 41",
	"*MakeBox.height: 37",
	"*MakeBox.label: ",
	"*MakeBox.fromHoriz: RollRight",
	"*MakeBox.fromVert: FrameBox",
	"*Line.width: 41",
	"*Line.height: 37",
	"*Line.label: ",
	"*Line.fromHoriz: MakeBox",
	"*Line.fromVert: DashBox",
	"*Arrow.width: 41",
	"*Arrow.height: 37",
	"*Arrow.label: ",
	"*Arrow.fromHoriz: RollRight",
	"*Arrow.fromVert: MakeBox",
	"*Circle.width: 41",
	"*Circle.height: 37",
	"*Circle.label: ",
	"*Circle.fromHoriz: Arrow",
	"*Circle.fromVert: Line",
	"*CircleFill.width: 41",
	"*CircleFill.height: 37",
	"*CircleFill.label: ",
	"*CircleFill.fromHoriz: RollRight",
	"*CircleFill.fromVert: Arrow",
	"*TextLabel.label: Input Data",
	"*TextDone.label: Done",
	"*TextCancel.label: Cancel",
	"*QuitCaution.label: Picture is Modified, but not Saved. Really Quit?",
	"*QuitDone.label: Quit",
	"*QuitDone.fromVert: QuitCaution",
	"*QuitCancel.label: Cancel",
	"*QuitCancel.fromHoriz: QuitDone",
	"*QuitCancel.fromVert: QuitCaution",
	NULL,
};

#else

extern Widget toplevel;
extern Widget Menu[23];
extern Widget Vpaned,Draw;
extern Cursor Mode_Cursor[C_CIRST+1];
extern int    Cursor_Mode[23];	

extern XtAppContext app_con;

extern GC gc,del_gc,sel_gc,dash_gc,xor_gc;

extern short fwidth, fheight;

#endif
