#define	MAIN_MODULE
#include "pe.h"
#include "glio.h" 
#include "popup.h" 

#define	DEFAULTGRID	8

extern int	create_box(int, int, int);
extern int	create_line(int, int, int);
extern int	create_circle(int, int, int);

extern int	deletegrp(int, int);
extern int	resizegrp(int, int);
extern int	editgrp(int, int);
extern int	movegrp(int, int);
extern int	copygrp(int, int);
extern int	grouping(int, int);
extern int	ungroup(int, int);

extern int	left_release_wait();
extern int	MakeGrid();

static 	scr_on();
static 	initialize();

typedef	int	(*PFII)(int, int);

static PFII	edit_funcs[] = {
	deletegrp,
	resizegrp,
	editgrp,
	movegrp,
	copygrp,
	grouping,
	ungroup
};

typedef	int	(*PFIII)(int, int, int);

static PFIII	draw_funcs[] = {
	create_box,
	create_box,
	create_box,
	create_line,
	create_line,
	create_circle,
	create_circle
};

int main(int argc,char *argv[])
{
	fputs("Picture Editor PE  Ver. 1.01\nCopyright (C) 1990 K. Ikeda\n",stderr);
	fputs("\nX-Window Version Ver. 1.7.0\nCopyright (C) 1994 T. Tabaru\n",stderr);
	fputs("\nX-Window Version Ver. 1.8.0\nCopyright (C) 2002 K. Ikeda\n",stderr);
	grid = oldgrid = -1;
	scr_filename[0]='\0';

	toplevel = XtVaAppInitialize(&app_con,"xpe",NULL,0,&argc,argv,
					fallback_resources, NULL);

	while (--argc>0) {
		if ( (*(argv[argc]+0)=='-')
		  && (*(argv[argc]+1)=='g') )
			grid = atoi(argv[argc]+2);
		else if ( (*(argv[argc]+0)=='-')
		  && (*(argv[argc]+1)=='G') )
			oldgrid = atoi(argv[argc]+2);
		else
			strcpy(scr_filename,argv[argc]);
	}
	if (grid<=0)		grid = DEFAULTGRID;
	if (oldgrid<=0)		oldgrid = DEFAULTGRID;
	org_x = org_y = 0;
	initialize();
	if (scr_filename[0]!='\0') finsub(scr_filename,TRUE);
	XtAppMainLoop(app_con);
}

static 	initialize()
{
	scr.group = NULL;
	scr.delgrp = NULL;
	mode = FRAMEBOXTYPE;
	modified = 1;
	scr_on();
}

static 	scr_on()
{
	g_init();
	redrawall();
	selobj(mode);
	selobj(mode);
}

selobj(int n)
{
	XDefineCursor(XtDisplay(Draw),XtWindow(Draw),
				Mode_Cursor[Cursor_Mode[n]]);
}

void mode_change(Widget w,XtPointer client_data,XtPointer call_data)
{
	mode = (int)client_data;
	selobj(mode);
}

void	DrawPicture(Widget w,XEvent *ev,String *params,Cardinal *num_params)
{
	int x,y;
	XEvent event;

	x = ev->xmotion.x;
	y = ev->xmotion.y;
	left_release_wait();

	if ((mode>=DELETE)&&(mode<=UNGROUP)) modified *= 
		(*edit_funcs[mode-DELETE])(org_x+x,org_y+y);
	if ((mode>=FRAMEBOXTYPE)&&(mode<=CIRCSTTYPE)) modified *=
		(*draw_funcs[mode-FRAMEBOXTYPE])(mode,org_x+x,org_y+y);
}

/****************************
*  miscellanious functions  *
*****************************/

global	int sign(int X)
{
	if	(X>0)	return 1;
	else if (X<0)	return -1;
	else		return 0;
}

global	overbox(BOXPOS *a,BOXPOS *b)
{return(((a->x2>=b->x1)&&(b->x2>=a->x1)&&(a->y2>=b->y1)&&(b->y2>=a->y1)));}

/* Search grp over the box */
global	GRP	*grp_over(BOXPOS *box)
{
	GRP	*grp;

	for (grp=scr.group; grp!=NULL; grp=grp->succ) {
		if (overbox(box,&(grp->box)))
			break;
	}
	return grp;
}

void	Move_org(Widget w, XtPointer client_data, XtPointer call_data)
{
	int n;
	int	tengrid = 10 * grid;

	n = (int)client_data;
	if (n==0)		org_x += tengrid;
	else if (n==1)		org_x -= tengrid;
	else if (n==2)		org_y -= tengrid;
	else if (n==3)		org_y += tengrid;
	g_cls();
	redrawall();
}

redrawall()
{
	GRP	*grp;

	MakeGrid();
	for (grp=scr.group; grp!=NULL; grp=grp->succ)
		redrawgrp(grp);
}

void Quit(Widget w,XtPointer client_data,XtPointer call_data)
{
      	XEvent event;

	if  (modified == 1 ) {
		fputs("xpe normal end.\n",stderr);	
		exit(0);
	}

	QuitPopup();

  	while ( modified == 0) {
      		XtAppNextEvent(app_con,&event);
      		XtDispatchEvent(&event);
	}
	modified = 0;

}

QuitPopup()
{
	Window rt,ch;
	int rx,ry,wx,wy;
	unsigned int state;

	XQueryPointer(XtDisplay(Draw),XtWindow(Draw),
				&rt,&ch,&rx,&ry,&wx,&wy,&state);
	XtVaSetValues(quitPopup, XtNx, rx - drwidth/2 - 200,
					XtNy, ry + drheight/2, NULL);

	XtPopup(quitPopup, XtGrabNone);
	XWarpPointer(XtDisplay(quitPopup),None,
			XtWindow(cancelQuit),0,0,0,0,10,10);
}

void quit(Widget w,XtPointer client_data,XtPointer call_data)
{
	XtPopdown(quitPopup);
	fputs("xpe end without save.\n",stderr);	
	exit(0);
}

void notQuit(Widget w,XtPointer client_data,XtPointer call_data)
{
	XtPopdown(quitPopup);
	modified = 1; 
}
