/*
*	Data Structures
*/

struct __BOXS {
	int	w;
	int	h;
	int	pos;
	int	n;
	char	s[1];
	int	ps;
};

struct __LINES {
	int	dir_x;
	int	dir_y;
	int	len;
};

struct __CIRCLES {
	int	di;
};

/*
*	Miscellanious types
*/

typedef	struct {
	int	x1;
	int	y1;
	int	x2;
	int	y2;
} BOXPOS;

typedef struct __OBJ {
	BOXPOS		box;	/* box position of the body */
	int		type;	/* FRAMEBOXTYPE, ... */
	int		x;	/* cardinal x */
	int		y;	/* cardinal y */
	union {
		struct __BOXS		framebox;
		struct __BOXS		dashbox;
		struct __BOXS		makebox;
		struct __CIRCLES	circle;
		struct __CIRCLES	circ;
		struct __LINES		line;
		struct __LINES		arrow;
	} body;
} OBJ;

typedef struct __ICELL{
	struct __ICELL	*pred;
	struct __ICELL	*succ;
	OBJ		*obj;
} ICELL;

typedef struct __GRP{
	struct __GRP	*pred;
	struct __GRP	*succ;
	BOXPOS		box;	/* group rectangle */
	ICELL		*first;
	ICELL		*last;
} GRP;

/*
*	SCR table
*/

typedef struct {
	GRP	*group;
	GRP	*delgrp;
} SCR;
