#include "glio.h"
#include "popup.h"
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <string.h>
#include <unistd.h>

extern char workdir[MAXPATHLEN];

char **getcwdls(int *no)
{
	DIR *dp;
	struct dirent *dir;
	struct stat sbuf;
	int n = 0,i,j;
	char *buf;
	char wbuf[MAXPATHLEN];
	char **filenamelist;

	if((dp = opendir(workdir)) == NULL) {
		return NULL;
	}

	while((dir = readdir(dp)) != NULL) {
		if(dir->d_ino == 0)
			continue;
		n++;
	}

	filenamelist = (char **)XtMalloc(sizeof(char *) * (n+1));

	rewinddir(dp); n = 0;

	while((dir = readdir(dp)) != NULL) {
		if(dir->d_ino == 0)
			continue;
		strcpy(wbuf,workdir);
		strcat(wbuf,dir->d_name);
		stat(wbuf,&sbuf);
		if (S_ISREG(sbuf.st_mode)) {
			buf = (char *)XtCalloc(strlen(dir->d_name)+1 
							,sizeof(char));
			strcpy(buf, dir->d_name);
		} else if (S_ISDIR(sbuf.st_mode)) {
			buf = (char *)XtCalloc(strlen(dir->d_name)+2 
							,sizeof(char));
			strcpy(buf, dir->d_name);
			strcat(buf,"/");
		}
		if(buf[0] != '.' || buf[strlen(buf)-1] == '/')
						filenamelist[n++] = buf;
	}

	closedir(dp); *no = n;

	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			if(strcmp(filenamelist[i],filenamelist[j])<0){
				buf=filenamelist[i];
				filenamelist[i]=filenamelist[j];
				filenamelist[j]=buf;
			}
		
	return(filenamelist);
}

InitTextPopup()
{
	extern void textdata_set(Widget, XtPointer, XtPointer);
	extern void textdata_cancel(Widget, XtPointer, XtPointer);
	extern epsf_set;

	textPopup = XtVaCreatePopupShell("TextInput",
			transientShellWidgetClass, Vpaned, NULL);

	textBox = XtVaCreateManagedWidget("",
			formWidgetClass, textPopup, NULL);

	textLabel = XtVaCreateManagedWidget("TextLabel",
			labelWidgetClass, textBox, XtNwidth, fwidth * 60,
			XtNborderWidth, 0, NULL);

	textDialog = XtVaCreateManagedWidget("TextDialog",
			asciiTextWidgetClass, textBox,
			XtNfromVert, textLabel, XtNeditType, XawtextEdit,
			XtNlength, MAXPATHLEN, XtNwidth, fwidth * 60, NULL);

	textDone = XtVaCreateManagedWidget("TextDone", commandWidgetClass,
			textBox, XtNfromVert, textDialog, NULL);


/*	textEpsf = XtVaCreateManagedWidget("TextEPSF",
			commandWidgetClass,textDialog,NULL);*/

	textCancel = XtVaCreateManagedWidget("TextCancel",
			commandWidgetClass, textBox, XtNfromVert, textDialog,
			XtNfromHoriz, textDone, NULL);

	XtAddCallback(textDone, XtNcallback, textdata_set, NULL);
/*	XtAddCallback(textEpsf, XtNcallback, epsf_set, NULL);*/
	XtAddCallback(textCancel, XtNcallback, textdata_cancel, NULL);
}

InitQuitPopup()
{
	extern void quit(Widget, XtPointer, XtPointer);
	extern void notQuit(Widget, XtPointer, XtPointer);

	quitPopup = XtVaCreatePopupShell("",
			transientShellWidgetClass, Vpaned, NULL);

	quitBox = XtVaCreateManagedWidget("",
			formWidgetClass, quitPopup, NULL);

	quitCaution = XtVaCreateManagedWidget("QuitCaution",
			labelWidgetClass, quitBox, NULL);
	
	reallyQuit = XtVaCreateManagedWidget("QuitDone", commandWidgetClass,
			quitBox, NULL);

	cancelQuit = XtVaCreateManagedWidget("QuitCancel",
			commandWidgetClass, quitBox, NULL);

	XtAddCallback(reallyQuit, XtNcallback, quit, NULL);
	XtAddCallback(cancelQuit, XtNcallback, notQuit, NULL);
}

InitFilePopup()
{
	int		nfiles;
	String		*filename;

	extern void namesel(Widget, XtPointer, XtPointer);
	extern void namesetdone(Widget, XtPointer, XtPointer);
	extern void namesetcancel(Widget, XtPointer, XtPointer);

	strcpy(workdir,getcwd(NULL,MAXPATHLEN));
	strcat(workdir,"/");
	filename = (String *)getcwdls(&nfiles);

	filePopup = XtVaCreatePopupShell("filePopup",
			transientShellWidgetClass, Vpaned, NULL);

	nameset = XtVaCreateManagedWidget("nameset",
			formWidgetClass,filePopup,
			XtNwidth,400,
			XtNheight,400, NULL);

	namelabel = XtVaCreateManagedWidget("Input filename",
			labelWidgetClass,nameset,
			XtNborderWidth,0, NULL);
	
	nametext = XtVaCreateManagedWidget("nametext",
			asciiTextWidgetClass,nameset,
			XtNfromVert,namelabel, XtNeditType,XawtextEdit,
			XtNlength,MAXPATHLEN, XtNstring,workdir,
			XtNwidth,380, NULL);

	namedone = XtVaCreateManagedWidget("namedone",
			commandWidgetClass,nameset,
			XtNfromVert,nametext, XtNlabel,"Done", NULL);

	namecancel = XtVaCreateManagedWidget("namecancel",
			commandWidgetClass,nameset,
			XtNfromVert,nametext, XtNfromHoriz,namedone,
			XtNlabel,"Cancel", NULL);

	nameview = XtVaCreateManagedWidget("nameview",
			viewportWidgetClass,nameset,
			XtNfromVert,namedone, XtNallowVert,TRUE,
			XtNheight,250, XtNwidth,380, NULL);

	namelist = XtVaCreateManagedWidget("namelist",
			listWidgetClass,nameview,
			XtNlist,filename, XtNnumberStrings,nfiles,
			XtNverticalList,TRUE, XtNwidth,380,NULL);

	XtAddCallback(namelist,XtNcallback,namesel,nametext);
	XtAddCallback(namedone,XtNcallback,namesetdone,nametext);
	XtAddCallback(namecancel,XtNcallback,namesetcancel,NULL);
}
